/*
 "CASTILLO"
 Jaime Vives, no(C) 1997
*/

// +-+-+-+ INCLUDES BASICOS +-+-+-+
#include "colors.inc"
#include "textures.inc"
#include "skies.inc"
#include "metals.inc"
#include "woods.inc"
#include "stones.inc"

// +-+-+-+ CONTROL DE TRAZADO +-+-+-+
#declare ladrillo_suave=1
#declare trazar_armas=1
#declare trazar_cortinas=1
#declare trazar_antorchas=1
#declare trazar_puertas=1
#declare trazar_resplandor=1
#declare trazar_pasillo=1
#declare trazar_escudos=1
#declare trazar_cielo=1
#declare trazar_tapiz=1
#declare trazar_area=1

// +-+-+-+ VARIABLES GLOBALES +-+-+-+
#declare pruebas=0
#declare luz_pruebas=0
#declare r1=seed(99)

// +-+-+-+ TEXTURAS +-+-+-+
#declare t_ladrillo=
texture{
      pigment{
       bozo
       turbulence 0.2
       color_map{
        [0 color Flesh]
        [1 color Tan]
       }
       scale .5
      }
      normal{granite .2 scale .06}
}

// +-+-+-+ CONSTRUCCION +-+-+-+
#if (trazar_pasillo=1)
// *** ladrillo base 1 ***
#declare ladrillo=
height_field{
 gif "ladrillo.gif"
 water_level 0.01
 #if (ladrillo_suave=1)
  smooth
 #end
 translate -.5
 rotate -90*x
 scale <1.2,1.2,.8>
}
// *** ladrillo base 2 ***
#declare ladrill2=
height_field{
 gif "ladrill2.gif"
 water_level 0.01
 #if (ladrillo_suave=1)
  smooth
 #end
 translate -.5
 rotate -90*x
 scale <1.2,1.2,.8>
}
// *** pared base ***
#declare desp=0
#declare qrot=0
#declare num_filas=20
#declare cnt_filas=0
#declare pared=
union{
#while (cnt_filas<=num_filas)
  #declare num_ladr=20
  #declare cnt_ladr=0
  #while (cnt_ladr<=num_ladr)
    object{
     #if (rand(r1)>.5)
      ladrillo
     #else
      ladrill2
     #end
     rotate qrot*z
     texture{
      t_ladrillo
      translate 100*rand(r1)
     }
     translate <cnt_ladr+desp+(-.03+.06*rand(r1)),cnt_filas*1.04+(-.03+.06*rand(r1)),-.5+(-.1+.2*rand(r1))>
    }
    #declare cnt_ladr=cnt_ladr+1
    #if (qrot=0)
      #declare qrot=90
    #else
     #if (qrot=90)
       #declare qrot=180
     #else
       #if (qrot=180)
         #declare qrot=270
       #else
         #if (qrot=270)
           #declare qrot=0
         #end
       #end
     #end
    #end
  #end
  #declare cnt_filas=cnt_filas+1
  #if (desp=0)
    #declare desp=0.5
  #else
    #declare desp=0
  #end
#end
 // *** cemento ***
 box{<0,-6,-.22>,<num_ladr,num_filas,.1> pigment{Tan+Flesh/2} normal{bumps scale 0.05} }
 translate <-num_ladr/2,0,0>
 scale <20,10,4>
}

// *** suelo base ***
#declare desp=0
#declare qrot=0
#declare num_filas=20
#declare cnt_filas=0
#declare suelo=
union{
#while (cnt_filas<=num_filas)
  #declare num_ladr=20
  #declare cnt_ladr=0
  #while (cnt_ladr<=num_ladr)
    object{
     #if (rand(r1)>.5)
      ladrillo
     #else
      ladrill2
     #end
     rotate qrot*z
     texture{
      T_Stone14 scale 3+3*rand(r1)
      translate 100*rand(r1)
     }
     translate <cnt_ladr+desp+(-.01+.02*rand(r1)),cnt_filas*1.04+(-.01+.02*rand(r1)),-.5+(-.05+.1*rand(r1))>
    }
    #declare cnt_ladr=cnt_ladr+1
    #if (qrot=0)
      #declare qrot=90
    #else
     #if (qrot=90)
       #declare qrot=180
     #else
       #if (qrot=180)
         #declare qrot=270
       #else
         #if (qrot=270)
           #declare qrot=0
         #end
       #end
     #end
    #end
  #end
  #declare cnt_filas=cnt_filas+1
  #if (desp=0)
    #declare desp=0.5
  #else
    #declare desp=0
  #end
#end
 box{<0,-6,-.22>,<num_ladr,num_filas,.1> pigment{Tan+Flesh/2} normal{bumps scale 0.05} }
 translate <-num_ladr/2,0,0>
 scale <10,10,3>
}

// *** cupula (o bovedas o como se llamen!) ***
#declare cupula=
   cylinder{
    <-110,0,0>
    < 110,0,0>
    20
    scale <1,1,2>
   }

// *** travesao ***
#declare t_mad_trav=
texture{T_Wood4 
 normal{wood .2 turbulence 0.1}
 scale 40 rotate 90*y
}
#declare travesanyo=
intersection{
 box{
  <-110,-15,-15>
  < 110, 15, 15>
 }
 cylinder{
  <-110,0,0>
  < 110,0,0>
  18
 }
}

// *** techo con travesaos y cupulas ***
#declare techo=
union{
 object{travesanyo
  translate <0,200,0>
  texture{t_mad_trav translate 100*rand(r1)}
 }
 object{travesanyo
  translate <0,200,100>
  texture{t_mad_trav translate 100*rand(r1)}
 }
 object{travesanyo
  translate <0,200,-100>
  texture{t_mad_trav translate 100*rand(r1)}
 }
 object{travesanyo
  translate <0,200,200>
  texture{t_mad_trav translate 100*rand(r1)}
 }
 intersection{
  union{
   object{cupula
    translate <0,190,50>
   }
   object{cupula
    translate <0,190,-50>
   }
   object{cupula
    translate <0,190,-150>
   }
   object{cupula
    translate <0,190, 150>
   }
  }
  plane{y,200inverse}
  hollow
  pigment{Tan} normal{bumps}
//  translate 5*y
 }
}

// *** construccion del pasillo ***
union{
 object{pared rotate -90*y translate -100*x}
 object{pared rotate  90*y translate  100*x}
 object{suelo rotate 90*x  scale <2,1,2> translate -8*y}
 object{techo}
}
union{
 object{pared rotate -90*y translate -100*x}
 object{pared rotate  90*y translate  100*x}
 object{suelo rotate 90*x  scale <2,1,2> translate -8*y}
 object{techo}
 translate 400*z
}
union{
 object{pared rotate -90*y translate -100*x}
 object{pared rotate  90*y translate  100*x}
 object{suelo rotate 90*x  scale <2,1,2> translate -8*y}
 object{techo}
 translate -400*z
}
union{
 object{pared rotate -90*y translate -100*x}
 object{pared rotate  90*y translate  100*x}
 object{suelo rotate 90*x scale <2,1,2> translate -8*y}
 object{techo}
 translate 800*z
}
union{
 object{pared rotate -90*y translate -100*x}
 object{pared rotate  90*y translate  100*x}
 object{suelo rotate 90*x scale <2,1,2> translate -8*y}
 object{techo}
 translate 1200*z
}

// *** pared al fondo ***
difference{
 object{pared}
 box{
  <-20, 30,-50>
  < 20,130, 50>
  pigment{Clear}
 }
 translate  1400*z
}
height_field{
 gif "vent01.gif"
 water_level 0.01
 translate -.5
 rotate -90*x
 texture{
  material_map{
   gif "vent02.gif"
   texture{pigment{Clear}}
   texture{t_ladrillo}
   texture{pigment{Bronze} normal{bumps scale 0.2} finish{Metal}}
   texture{pigment{Copper} normal{dents scale 0.2} finish{Metal}}
   texture{Glass}
  }
  translate -.5
 }
 scale <60,120,20>
 translate <0,84,1395>
}
light_source{
 <500,5000,9000>
 color White+SkyBlue/2+Gold/2
}
light_source{
 <0,80,1380>
 color White/2.5+SkyBlue/5+Gold/5
 fade_distance 500
 fade_power 2
}
#end // trazar_pasillo

// +-+-+-+ PUERTAS +-+-+-+
#if (trazar_puertas=1)
// *** puerta base ***
#declare puerta=
height_field{
 gif "arcob.gif"
 smooth
 water_level 0.01
 translate -.5
 rotate -90*x
 texture{
  material_map{
   gif "arco2.gif"
   texture{t_ladrillo scale 20}
   texture{t_ladrillo scale 20}
   texture{pigment{Bronze} normal{bumps scale 0.2} finish{Metal}}
   texture{pigment{Copper} normal{dents scale 0.2} finish{Metal}}
   texture{pigment{DarkBrown} normal{bumps scale 0.2} finish{Metal}}
  }
  translate -.5
 }
 scale <120,170,8>
 translate (170/2)*y
}

// *** colocacion de las puertas ***
union{
 object{puerta
  rotate -90*y
  translate <-95,0,200>
 }
 object{puerta
  rotate 90*y
  translate <95,0,200>
 }
 object{puerta
  rotate -90*y
  translate <-95,0,1000>
 }
 object{puerta
  rotate 90*y
  translate <95,0,1000>
 }
 translate -4*y
}
#end // if puertas

// +-+-+-+ ANTORCHAS +-+-+-+
#if (trazar_antorchas=1)
// *** antorcha base ***
#declare antorcha_conluz=
union{
 // +-+ soporte +-+
 box{
  <-2.5,1,-2.5>
  <2.5,3,2.5>
  texture{Bronze_Texture}
 }
 cone{
  <0,-1,0>,3
  <0,6,0>,4
  texture{Bronze_Texture}
  rotate -15*z
  translate 2.5*x
 }
 // +-+ antorcha +-+
 cone{
  <0,-5,0>,2
  <0,10,0>,5
  texture{T_Wood15}
  rotate -15*z
  translate 2.5*x
 }
 // +-+ fuego +-+
 sphere{
  <0,0,0>,1
  hollow
  texture{
   pigment { color rgbt <1,1,1,1>}
     halo {
       emitting
       spherical_mapping
       linear
       turbulence .6
       color_map {
         [ 0.0 color rgbt <1, 0, 0,  1> ]
         [ 0.2 color rgbt <1, 0, 0, -1> ]
         [ 0.7 color rgbt <1, 1, 0, -1> ]
         [ 1.0 color rgbt <1, 0, 0,  -1> ]
       }
       frequency 3
       samples 20
       scale 0.5
     }
  }
  scale <6,11,6>
  translate 11.5*y
//  rotate -15*z
  translate 5*x
 }
 #if (trazar_resplandor=1)
 sphere{
   <0,0,0>,1
   hollow
   no_shadow
   texture{
   pigment { color rgbt <1,1,1,1>}
    halo {
      emitting
      spherical_mapping
      linear
      turbulence .1
      color_map {
        [ 0.0 Gold transmit 1]
        [ 1.0 Orange filter 0.9 transmit -1 ]
      }
      frequency 1
      samples 20
      scale 0.4
    }
   }
   scale 25
   translate 14*y
//   rotate -15*z
   translate 5*x
 }
 #end
 // +-+ luz +-+
 #if (luz_pruebas=0)
 light_source{
  <0,16,0>
  color Gold*0.5
  #if (trazar_area=1)
   area_light <1,0,0>,<0,1,0>,4,4 jitter
  #end
  fade_distance 250
  fade_power 6
  atmosphere on
  atmospheric_attenuation on
  rotate -15*z
  translate 2.5*x
 }
 #end // if luz pruebas
}
#declare antorcha_sinluz=
union{
 // +-+ soporte +-+
 box{
  <-2.5,1,-2.5>
  <2.5,3,2.5>
  texture{Bronze_Texture}
 }
 cone{
  <0,-1,0>,3
  <0,6,0>,4
  texture{Bronze_Texture}
  rotate -15*z
  translate 2.5*x
 }
 // +-+ antorcha +-+
 cone{
  <0,-5,0>,2
  <0,10,0>,5
  texture{T_Wood15}
  rotate -15*z
  translate 2.5*x
 }
}
// *** colocacion de las antorchas ***
object{antorcha_conluz
 translate <-95,100,120>
}
object{antorcha_conluz
 rotate 180*y
 translate < 95,100,120>
}
object{antorcha_conluz
 translate <-95,100,280>
}
object{antorcha_conluz
 rotate 180*y
 translate < 95,100,280>
}
object{antorcha_sinluz
 translate <-95,100,920>
}
object{antorcha_sinluz
 rotate 180*y
 translate < 95,100,920>
}
object{antorcha_sinluz
 translate <-95,100,1080>
}
object{antorcha_sinluz
 rotate 180*y
 translate < 95,100,1080>
}
#end // if antorchas

// +-+-+-+ ARMAS +-+-+-+
#if (trazar_armas=1)
/*
// *** mazo iberico ***
#declare mazo=
union{
 lathe{
  cubic_spline
  10
  <0,1>
  <0,0>
  <.4,1>
  <.5,4>
  <1.5,7>
  <1.5,9.5>
  <1,10.5>
  <.5,10.7>
  <0,11>
  <0,12>
 }
 #declare num_fil=6
 #declare cnt_fil=1
 #while (cnt_fil<=num_fil)
  #declare num_con=4
  #declare cnt_con=1
  #while (cnt_con<=num_con)
   cone{
    <0,0,0>,.3
    <0,0,-1>,0.01
    translate <0,5+cnt_con*1.2,-1.1-(1-abs(-3+cnt_con)/num_con)>
    rotate (-num_con+num_con*2)*x
    rotate (360*cnt_fil/num_fil)*y
   }
   #declare cnt_con=cnt_con+1
  #end
  #declare cnt_fil=cnt_fil+1
 #end
 texture{
  pigment{Gray20}
  normal{dents}
  finish{F_MetalA}
 }
}
#declare armas1=
union{
 object{mazo rotate 45*z translate 2*x}
 object{mazo rotate -45*z translate -2*x}
 translate -5*y
 scale 3
}
// colocacion de armas y escudos ***
object{armas1
 rotate -90*y
 translate <-90,80,75>
}
object{armas1
 rotate -90*y
 translate <-90,80,325>
}
object{armas1
 rotate 90*y
 translate <90,80,75>
}
object{armas1
 rotate 90*y
 translate <90,80,325>
}
*/
// *** hacha ***
#declare t_hmango=
texture{T_Wood11}
#declare t_hfilo=
texture{
// pigment{Gray30+SteelBlue/2}
// finish{Metal reflection 0.1}
 Chrome_Texture
}
#declare rad_hsup=2.2
#declare rad_hinf=1.1
#declare hacha=
union{
 difference{
  difference{
   sphere{
    <0,12,0>,12
    scale <1,1,0.1>
   }
   torus{
    12,2
    rotate 90*x
    scale <1,1,.5>
    translate <0,12,-1>
   }
   torus{
    12,2
    rotate 90*x
    scale <1,1,.5>
    translate <0,12,1>
   }
   bounded_by{
    sphere{
     <0,12,0>,12.1
     scale <1,1,0.1>
    }
   }
  }
  sphere{<0,12+8,0>,5}
  sphere{<0,12-8,0>,5}
  bounded_by{
   sphere{
    <0,12,0>,12.1
    scale <1,1,0.1>
   }
  }
  texture{t_hfilo}
 }
 cone{
  <0,12+8-5+1,0>,1.4
  <0,12-8+5-1,0>,1.6
  texture{t_hfilo}
 }
 union{
  cone{
   <0,-20,0>,rad_hsup
   <0, 20,0>,rad_hinf
  }
  sphere{
   <0,-20,0>,rad_hsup
  }
  sphere{
   <0, 20,0>,rad_hinf
  }
  texture{t_hmango}
 }
}

#declare armas2=
union{
 object{hacha
  rotate 40*z
  translate -7*x
 }
 object{hacha
  rotate -40*z
  translate 3*z
  translate 7*x
 }
 rotate -2*x
}
// colocacion de armas y escudos ***
object{armas2
 rotate -90*y
 translate <-92,60,75>
}
object{armas2
 rotate -90*y
 translate <-92,60,325>
}
object{armas2
 rotate 90*y
 translate <92,60,75>
}
object{armas2
 rotate 90*y
 translate <92,60,325>
}
#end // if armas

#if (trazar_cortinas=1)
#declare cort_base=
height_field{
 gif "hf_cort3.gif"
 water_level 0.01
 translate -.5
 rotate -90*x
}
object{cort_base
 scale <190,400,10>
 texture{
  pigment{Firebrick}
 }
 translate <0,201,540>
}
object{cort_base
 rotate 180*y
 rotate 180*x
 scale <190,400,10>
 texture{
  pigment{Firebrick}
 }
 translate <0,201,1340>
}
#end // if cortinas

// +-+-+-+ HERALDICA +-+-+-+
#if (trazar_escudos=1)
#declare escudo=
union{
 height_field{
  gif "alve-01b.gif"
  translate -.5
 }
 box{
  <-.5, 0.4,-.5>
  < .5, 2, .5>
 }
 rotate -90*x
 texture{
//  T_Stone11
  pigment{
   image_map{
    gif "alve-01a.gif"
   }
   translate -.5
  }
 }
 scale <350,504,12>
 scale 0.12
 rotate 90*y
}
object{escudo
 translate <-95,115,75>
}
object{escudo
 translate <-95,115,325>
}
object{escudo
 rotate 180*y
 translate <95,115,75>
}
object{escudo
 rotate 180*y
 translate <95,115,325>
}
#end // trazar_escudos

#if (trazar_tapiz=1)
// +-+-+-+ TAPICES +-+-+-+
#declare tapiz1=
union{
 box{
  <-50,-40,-1>
  < 50, 40, 1>
 }
 #declare num_hil=1000
 #declare cnt_hil=1
 #while (cnt_hil<=num_hil)
  cylinder{
   <0,0.5,1>
   <0,0,1.5>
   .05
   rotate (-2*4*rand(r1))*y
   translate <-50+100*rand(r1),-40+80*rand(r1),0>
  }
  #declare cnt_hil=cnt_hil+1
 #end
}
object{tapiz1
 texture{
  pigment{
   image_map{
    gif "tapiz1.gif"
   }
   translate -.5
   scale <100,80,1>
  }
  normal{granite scale <1,10,1>}
  finish{metallic}
 }
 rotate -90*y
 translate <-97,90,-25>
}
object{tapiz1
 texture{
  pigment{
   image_map{
    gif "tapiz2.gif"
   }
   translate -.5
   scale <100,80,1>
  }
  normal{granite scale <1,10,1>}
  finish{metallic}
 }
 rotate -90*y
 translate <-97,90,425>
}
object{tapiz1
 texture{
  pigment{
   image_map{
    gif "tapiz1.gif"
   }
   translate -.5
   scale <100,80,1>
  }
  normal{granite scale <1,10,1>}
  finish{metallic}
 }
 rotate 90*y
 translate <97,90,-25>
}
object{tapiz1
 texture{
  pigment{
   image_map{
    gif "tapiz2.gif"
   }
   translate -.5
   scale <100,80,1>
  }
  normal{granite scale <1,10,1>}
  finish{metallic}
 }
 rotate 90*y
 translate <97,90,425>
}
#end // if tapiz

// +-+-+-+ EXTERIOR +-+-+-+
#if (trazar_cielo=1)
#declare CloudColors = color_map {
    [0.0 0.6 color MidnightBlue color Gray]
    [1.0 color White]
}
#declare CloudTexture = texture {
   pigment{
      bozo
      turbulence 0.7
      octaves 3
      lambda 6
      color_map { CloudColors }
   }
   finish { ambient 1 diffuse 0 }
   scale 1/6
}
sphere {
   <0, 0, 0>, 1
   hollow
   texture { CloudTexture }
   scale <395602.111816, 39560.211182, 395602.111816>
   rotate 30*y
}
#end

// +-+-+-+ CAMARA, LUCES, ...ACCION! +-+-+-+
#declare desde=<80,50,-250>
#declare hacia=<-50,80,200>
#declare zoom=1.8*z
camera{
 location desde
 direction zoom
 look_at hacia
}
#if (luz_pruebas=1)
light_source{
 desde color White
}
#end

/*
#declare fantasma=
height_field{
 gif "fantasma.gif"
 water_level 0.01
 smooth
 translate -.5
 rotate -90*x
}
union{
object{fantasma
 hollow
 texture{
  pigment{
   gradient y
   color_map{
    [0 color White filter 0.7]
    [1 color Clear]
   }
   translate .5*y
  }
  finish{Luminous}
 }
}
scale <200,400,50>
scale .4
translate 400*0.4*0.5*y
translate 600*z
}
*/
